> module Bindings (tick,display,reshape,keyboardMouse) where
> import Graphics.Rendering.OpenGL
> import Graphics.UI.GLUT
> import Data.IORef
> import Control.Monad
> import Display
> import Entities
> import Maths

> reshape :: Size -> IO()
> reshape s = do 
>  viewport $= (Position 0 0, s)

> movePlayer :: IORef (GameState) -> Int -> Int -> IO()
> movePlayer gamestate a b = do
>   GameState{entity=Entity{pos=pa}} <-  get (gamestate)
>   modifyIORef gamestate 
>                   (\g@GameState{entity=e@Entity{pos=p}}->g{entity=e{pos=trans p a b}}) 

> keyboardAct :: IORef (GameState) -> Key -> KeyState -> IO()

> keyboardAct gamestate (SpecialKey KeyLeft) Down = 
>     movePlayer gamestate (-1) 0
> keyboardAct gamestate (SpecialKey KeyRight) Down = 
>     movePlayer gamestate 1 0
> keyboardAct gamestate (SpecialKey KeyUp) Down = 
>     movePlayer gamestate 0 1
> keyboardAct gamestate (SpecialKey KeyDown) Down = 
>     movePlayer gamestate 0 (-1)
> keyboardAct _ _ _ = return ()


> keyboardMouse :: IORef (GameState) -> Key -> KeyState -> t -> t1 -> IO()
> keyboardMouse  pos key state modifiers position = 
>     keyboardAct  pos key state
